/*
 *  arch/arm/mach-comcerto/include/mach/otp.h
 *
 *  Copyright (C) Mindspeed Technologies, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 *
 */

#ifndef _OTP_H_
#define _OTP_H_

#define COMCERTO_OTP_DELAY	1000

#define COMCERTO_OTP_SIZE_BITS	(8 * 1024)	/* 8192 Bits */
#define COMCERTO_OTP_SIZE_BYTES	(1024)		/* 1K Bytes  */

#define DOUT_COUNTER_VALUE	0x1F

#define COMCERTO_OTP_CONFIG_LOCK_0       APB_VADDR(COMCERTO_APB_OTP_BASE + 0x00)
#define COMCERTO_OTP_CONFIG_LOCK_1       APB_VADDR(COMCERTO_APB_OTP_BASE + 0x04)
#define COMCERTO_OTP_CEB_SEQUENCE_LOCKS  APB_VADDR(COMCERTO_APB_OTP_BASE + 0x08)
#define COMCERTO_OTP_CEB_INPUT           APB_VADDR(COMCERTO_APB_OTP_BASE + 0x0C)
#define COMCERTO_OTP_RSTB_INPUT          APB_VADDR(COMCERTO_APB_OTP_BASE + 0x10)
#define COMCERTO_OTP_ADDR_INPUT          APB_VADDR(COMCERTO_APB_OTP_BASE + 0x14)
#define COMCERTO_OTP_READEN_INPUT        APB_VADDR(COMCERTO_APB_OTP_BASE + 0x18)
#define COMCERTO_OTP_DATA_INPUT          APB_VADDR(COMCERTO_APB_OTP_BASE + 0x1C)
#define COMCERTO_OTP_DLE_INPUT           APB_VADDR(COMCERTO_APB_OTP_BASE + 0x20)
#define COMCERTO_OTP_WEB_INPUT           APB_VADDR(COMCERTO_APB_OTP_BASE + 0x24)
#define COMCERTO_OTP_WEB_COUNTER         APB_VADDR(COMCERTO_APB_OTP_BASE + 0x28)
#define COMCERTO_OTP_PGMEN_INPUT         APB_VADDR(COMCERTO_APB_OTP_BASE + 0x2C)
#define COMCERTO_OTP_PGM2CPUMP_COUNTER   APB_VADDR(COMCERTO_APB_OTP_BASE + 0x30)
#define COMCERTO_OTP_CPUMPEN_INPUT       APB_VADDR(COMCERTO_APB_OTP_BASE + 0x34)
#define COMCERTO_OTP_CPUMP2WEB_COUNTER   APB_VADDR(COMCERTO_APB_OTP_BASE + 0x38)
#define COMCERTO_OTP_WEB2CPUMP_COUNTER   APB_VADDR(COMCERTO_APB_OTP_BASE + 0x3C)
#define COMCERTO_OTP_CPUMP2PGM_COUNTER   APB_VADDR(COMCERTO_APB_OTP_BASE + 0x40)
#define COMCERTO_OTP_CLE_INPUT           APB_VADDR(COMCERTO_APB_OTP_BASE + 0x44)
#define COMCERTO_OTP_SECURE_LOCK_OUTPUT  APB_VADDR(COMCERTO_APB_OTP_BASE + 0x48)
#define COMCERTO_OTP_DATA_OUT_COUNTER    APB_VADDR(COMCERTO_APB_OTP_BASE + 0x4C)
#define COMCERTO_OTP_DATA_OUTPUT         APB_VADDR(COMCERTO_APB_OTP_BASE + 0x50)
#define COMCERTO_OTP_HW_SEC_MODE_STATUS  APB_VADDR(COMCERTO_APB_OTP_BASE + 0x54)

/* Information added in Documentation/ioctl/ioctl-number.txt */

#define COMCERTO_OTPIOC_BASE       'O'
#define COMCERTO_OTPIOC_OPS_BIT         _IO(COMCERTO_OTPIOC_BASE, 0x07)
#define COMCERTO_OTPIOC_OPS_BYTE        _IO(COMCERTO_OTPIOC_BASE, 0x08)
#define COMCERTO_OTPIOC_OPS_MODE        _IOR(COMCERTO_OTPIOC_BASE, 0x09, uint32_t)
#define COMCERTO_OTPIOC_WR_ENABLE       _IO(COMCERTO_OTPIOC_BASE, 0x0A)
#define COMCERTO_OTPIOC_WR_DISABLE      _IO(COMCERTO_OTPIOC_BASE, 0x0B)

#define COMCERTO_OTP_OPS_BIT    0x0
#define COMCERTO_OTP_OPS_BYTE   0x1

#define COMCERTO_OTP_WR_DISABLE 0x0
#define COMCERTO_OTP_WR_ENABLE  0x1

#endif /* _OTP_H_ */
